/**
  Main initialisation routine. 
  @param none
  @author Martin Pallesch
  @version 1.0
  @return nothing
*/


// invokedAESUserFunc
/**
Purpose: cell action
		    
Usage: Internal function

PVSS manager usage: Ctrl, NG, NV

Constraints:
	. PVSS version: 3.0.1
	. operating system: XP and W2000
	. distributed system: yes.
*/

void invokedAESUserFunc( string shapeName, int screenType, int tabType, int row, int column, string value )
{
bool granted;
int iNb, iHistoric;
string sDpe, sDeviceName, sDescription, sType, s;
dyn_string dsUnicosObjects, exceptionInfo;

	getValue (shapeName, "cellValueRC", row, _DPID_, sDpe); //get Dpe
	sDeviceName=unGenericDpFunctions_getDpName(sDpe);				//get DpName

  switch (column)
		{
		// "S" -> Open default panel
		case 13:						
  		getValue (shapeName, "cellValueRC", row, "s", s); //Get S
  		if (s=="S")
	  		{
	  		getValue (shapeName, "cellValueRC", row, "description", sDescription); //Get Alias and Description
				unAlertPanel_DefaultPanel(sDeviceName, sDescription);
				}
			break;
		
		// "Ack." -> Acknowledgment
		case 12:
			if (value == " !!! " && sDeviceName!="")
				{				
				if (shapeExists("TimeRange"))
					{
					getValue("TimeRange", "number", iHistoric);	
					}
				else
					{
					iHistoric=-1;
					}
				
				if (iHistoric!=2) //if Closed Mode => not able to ack.
					{
					sType = dpTypeName(sDeviceName);
							
					unGenericDpFunctions_getUnicosObjects(dsUnicosObjects);
					if (dynContains(dsUnicosObjects, sType) > 0)
						{						
						unGenericButtonFunctionsHMI_isAccessAllowed(sDeviceName, sType, UN_FACEPLATE_BUTTON_ACK_ALARM, granted, exceptionInfo);
						if (granted)
							{
//							unGenericObject_Acknowledge(sDeviceName, exceptionInfo);
							unGenericObject_Acknowledge(dpSubStr(sDpe, DPSUB_SYS_DP_EL), exceptionInfo);
							}
						}
					else
						{
						unGenericButtonFunctionsHMI_isAccessAllowed(sDeviceName, UN_GENERIC_USER_ACCESS, UN_FACEPLATE_BUTTON_ACK_ALARM, granted, exceptionInfo);
						if (granted)
							{
//DebugN(sDpe, dpSubStr(sDpe, DPSUB_SYS_DP_EL));
							unAlarmConfig_acknowledge(dpSubStr(sDpe, DPSUB_SYS_DP_EL), exceptionInfo);
							}
						}
					
					if (!granted)
						{
						fwException_raise(exceptionInfo, "ERROR", "invokedAESUserFunc(): You don't have permission to aknowledge: " + unGenericDpFunctions_getAlias(sDeviceName), "");
						}
	
					if (dynlen(exceptionInfo)>0)
						{
						if(isFunctionDefined("unMessageText_sendException"))
							{
							unMessageText_sendException("*", "*", "unAlertScreen", "user", "*", exceptionInfo);
							}
						}						
					}
				}
			break;
		
		default:
			DebugN("invokedAESUserFunc() - Column unknown: "+column);
		}
}
